Attribute VB_Name = "WinHeader_i"
Option Explicit
'
'   WinHeader_i :: Windows API include file
'
'   (c)1999,2000 k23 productions / kfi systems Ltd.
'   All Rights Reserved.
'
'   Developed by Chris Peel (chris@kfisystems.freeserve.co.uk)
'       v32.1   (20-Feb-2000)
'       v32.200 (15-Apr-2000)   - Added ExtractIconEx() declare and
'                                 DI_ constants.
'       v32.210 (17-Apr-2000)   - Added extra Window functions.
'
'       v32.211 (20-Apr-2000)   - More window handling stuff.
'
'    v32.220 (22-Jun-2000)
'       o All Class Styles, IDC's and other window creation-related stuff added.
'
'==========================================
' CONSTANTS
'==========================================

Public Const STATUS_WAIT_0 = &H0
Public Const WAIT_OBJECT_0 = ((STATUS_WAIT_0) + 0)

Public Const SMTO_ABORTIFHUNG = &H2
'
' Standard cursors
'
Public Const IDC_ARROW = 32512&
Public Const IDC_IBEAM = 32513&
Public Const IDC_WAIT = 32514&
Public Const IDC_CROSS = 32515&
Public Const IDC_UPARROW = 32516&
Public Const IDC_SIZE = 32640&
Public Const IDC_ICON = 32641&
Public Const IDC_SIZENWSE = 32642&
Public Const IDC_SIZENESW = 32643&
Public Const IDC_SIZEWE = 32644&
Public Const IDC_SIZENS = 32645&
Public Const IDC_SIZEALL = 32646&
Public Const IDC_NO = 32648&
Public Const IDC_APPSTARTING = 32650&
'
' Window Class Styles
'
Public Const CS_VREDRAW = &H1
Public Const CS_HREDRAW = &H2
Public Const CS_KEYCVTWINDOW = &H4
Public Const CS_DBLCLKS = &H8
Public Const CS_OWNDC = &H20
Public Const CS_CLASSDC = &H40
Public Const CS_PARENTDC = &H80
Public Const CS_NOKEYCVT = &H100
Public Const CS_NOCLOSE = &H200
Public Const CS_SAVEBITS = &H800
Public Const CS_BYTEALIGNCLIENT = &H1000
Public Const CS_BYTEALIGNWINDOW = &H2000
Public Const CS_PUBLICCLASS = &H4000
'
' Window Styles
'
' Any constants marked '*' are combined to identify a 'normal' task
' window.  That is, one that would appear in the Window's task bar
'
Public Const WS_POPUP           As Long = &H80000000
Public Const WS_CHILD           As Long = &H40000000
Public Const WS_MINIMIZE        As Long = &H20000000    ' window is minimized
Public Const WS_VISIBLE         As Long = &H10000000    ' *
Public Const WS_DISABLED        As Long = &H8000000
Public Const WS_CLIPSIBLINGS    As Long = &H4000000
Public Const WS_CLIPCHILDREN    As Long = &H2000000
Public Const WS_MAXIMIZE        As Long = &H1000000
Public Const WS_BORDER          As Long = &H800000      ' *
Public Const WS_DLGFRAME        As Long = &H400000      ' *
Public Const WS_VSCROLL         As Long = &H200000
Public Const WS_HSCROLL         As Long = &H100000
Public Const WS_SYSMENU         As Long = &H80000
Public Const WS_THICKFRAME      As Long = &H40000       ' *
Public Const WS_GROUP           As Long = &H20000       ' top of group
Public Const WS_TABSTOP         As Long = &H10000
Public Const WS_OVERLAPPED      As Long = 0

Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_MAXIMIZEBOX = &H10000
'
' Pre-defined settings
'
Public Const WS_CAPTION = WS_BORDER Or WS_DLGFRAME
Public Const WS_TILED = WS_OVERLAPPED
Public Const WS_ICONIC = WS_MINIMIZE
Public Const WS_SIZEBOX = WS_THICKFRAME
Public Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
Public Const WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW
Public Const WS_POPUPWINDOW = (WS_POPUP Or WS_BORDER Or WS_SYSMENU)
Public Const WS_CHILDWINDOW = (WS_CHILD)
'
' Window Extended Styles
'
Public Const WS_EX_LAYERED          As Long = &H80000
Public Const WS_EX_APPWINDOW        As Long = &H40000
Public Const WS_EX_STATICEDGE       As Long = &H20000
Public Const WS_EX_CONTROLPARENT    As Long = &H10000
Public Const WS_EX_RIGHTSCROLLBAR   As Long = &H0
Public Const WS_EX_LEFTSCROLLBAR    As Long = &H4000
Public Const WS_EX_LTRREADING       As Long = &H0
Public Const WS_EX_RTLREADING       As Long = &H2000
Public Const WS_EX_LEFT             As Long = &H0
Public Const WS_EX_RIGHT            As Long = &H1000
Public Const WS_EX_CONTEXTHELP      As Long = &H400
Public Const WS_EX_CLIENTEDGE       As Long = &H200
Public Const WS_EX_WINDOWEDGE       As Long = &H100
Public Const WS_EX_TOOLWINDOW       As Long = &H80
Public Const WS_EX_MDICHILD         As Long = &H40
Public Const WS_EX_TRANSPARENT      As Long = &H20
Public Const WS_EX_ACCEPTFILES      As Long = &H10
Public Const WS_EX_TOPMOST          As Long = &H8
Public Const WS_EX_NOPARENTNOTIFY   As Long = &H4
Public Const WS_EX_DLGMODALFRAME    As Long = &H1
'
' Windows2000 LayeredWindowAttributes()
'
Public Const LWA_ALPHA = &H2


Public Const SPI_GETWORKAREA& = 48
Public Const SPI_SETWORKAREA& = 47
'
' InsertAfter constants for SetWindowPos()
'
Public Const HWND_TOP       As Long = 0      ' move to top of z-order
Public Const HWND_BOTTOM    As Long = 1
Public Const HWND_TOPMOST   As Long = -1
Public Const HWND_NOTOPMOST As Long = -2
'
' special window handles
'
Public Const HWND_BROADCAST = &HFFFF&
'
' Flags for SetWindowPos()
'
Public Const SWP_NOSIZE = &H1          ' Do not re-size window
Public Const SWP_NOMOVE = &H2          ' Do not reposition window
Public Const SWP_NOZORDER = &H4        ' Don't change z-order
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40     ' Make window visible/active
Public Const SWP_HIDEWINDOW = &H80

Public Const GW_HWNDFIRST = 0           ' Get first Window handle
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2            ' Get next window handle
Public Const GW_HWNDPREV = 3
Public Const GW_OWNER = 4
Public Const GW_CHILD = 5               ' First child window

Public Const GWL_EXSTYLE = (-20)
Public Const GWL_STYLE = (-16)          ' Get Window's style bits
Public Const GWL_ID = (-12)             ' Get ID of child
Public Const GWL_HWNDPARENT = (-8)      ' Get ID of parent
Public Const GWL_WNDPROC  As Long = (-4)

Public Const ICON_SMALL         As Long = 0&
Public Const ICON_BIG           As Long = 1&

Public Const GCL_HICON = (-14)
Public Const GCL_WNDPROC = (-24)
Public Const GCL_HICONSM = (-34)


' ListView control (used when hiding desktop icons)
Public Const LVM_FIRST = &H1000
Public Const LVM_GETTITEMCOUNT& = (LVM_FIRST + 4)
Public Const LVM_DELETEITEM = (LVM_FIRST + 8)
Public Const LVM_DELETEALLITEMS = (LVM_FIRST + 9)
Public Const LVM_SETITEMPOSITION& = (LVM_FIRST + 15)
Public Const LVM_GETITEMPOSITION = (LVM_FIRST + 16)
Public Const LVM_GETITEMTEXT = LVM_FIRST + 45
'
' Window Messages
'
Public Const WM_NULL = &H0
Public Const WM_CREATE = &H1
Public Const WM_DESTROY = &H2
Public Const WM_MOVE = &H3
Public Const WM_SIZE = &H5
Public Const WM_ACTIVATE = &H6&
Public Const WM_PAINT = &HF
Public Const WM_CLOSE = &H10&
Public Const WM_ERASEBKGND = &H14
Public Const WM_WININICHANGE = &H1A
Public Const WM_SETTINGCHANGE = WM_WININICHANGE
Public Const WM_ACTIVATEAPP = &H1C&
Public Const WM_MOUSEACTIVATE = &H21&
Public Const WM_QUERYDRAGICON = &H37
Public Const WM_WINDOWPOSCHANGING = &H46
Public Const WM_WINDOWPOSCHANGED = &H47
Public Const WM_COPYDATA = &H4A

Public Const WM_CONTEXTMENU         As Long = &H7B
Public Const WM_STYLECHANGING       As Long = &H7C
Public Const WM_STYLECHANGED        As Long = &H7D
Public Const WM_DISPLAYCHANGE       As Long = &H7E
Public Const WM_GETICON             As Long = &H7F
Public Const WM_SETICON             As Long = &H80

Public Const WM_NCPAINT = &H85
Public Const WM_NCMOUSEMOVE = &HA0
Public Const WM_NCLBUTTONDOWN = &HA1&
Public Const WM_NCLBUTTONUP = &HA2
Public Const WM_NCLBUTTONDBLCLK = &HA3
Public Const WM_NCRBUTTONDOWN = &HA4
Public Const WM_NCRBUTTONUP = &HA5
Public Const WM_NCRBUTTONDBLCLK = &HA6
Public Const WM_NCMBUTTONDOWN = &HA7
Public Const WM_NCMBUTTONUP = &HA8
Public Const WM_NCMBUTTONDBLCLK = &HA9
Public Const WM_COMMAND = &H111&
Public Const WM_SYSCOMMAND = &H112&
Public Const WM_TIMER = &H113

Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208
Public Const WM_MBUTTONDBLCLK = &H209
Public Const WM_PARENTNOTIFY = &H210
Public Const WM_SIZING = &H214
Public Const WM_CAPTURECHANGED = &H215
Public Const WM_MOVING = &H216
Public Const WM_ENTERSIZEMOVE = &H231
Public Const WM_EXITSIZEMOVE = &H232


Public Const WM_HOTKEY          As Long = &H312&
Public Const WM_GETSYSMENU      As Long = &H313&    ' not documented




' Message sub-types
Public Const WA_INACTIVE        As Long = 0&
Public Const WA_ACTIVE          As Long = 1&
Public Const WA_CLICKACTIVE     As Long = 2&

Public Const MA_ACTIVATE        As Long = 1&
Public Const MA_ACTIVATEANDEAT  As Long = 2&

Public Const LP_HT_CAPTION      As Long = 2
Public Const HTCAPTION = 2
Public Const HTBOTTOMRIGHT = 17
Public Const HTGROWBOX = 4


Public Const SC_CLOSE           As Long = &HF060&
Public Const SC_SCREENSAVE      As Long = &HF140&

Public Const MK_LBUTTON = &H1
Public Const MK_RBUTTON = &H2
Public Const MK_SHIFT = &H4
Public Const MK_CONTROL = &H8
Public Const MK_MBUTTON = &H10


'
' Colours
'
Public Const COLOR_SCROLLBAR = 0
Public Const COLOR_BACKGROUND = 1
Public Const COLOR_ACTIVECAPTION = 2
Public Const COLOR_INACTIVECAPTION = 3
Public Const COLOR_MENU = 4
Public Const COLOR_WINDOW = 5
Public Const COLOR_WINDOWFRAME = 6
Public Const COLOR_MENUTEXT = 7
Public Const COLOR_WINDOWTEXT = 8
Public Const COLOR_CAPTIONTEXT = 9
Public Const COLOR_ACTIVEBORDER = 10
Public Const COLOR_INACTIVEBORDER = 11
Public Const COLOR_APPWORKSPACE = 12
Public Const COLOR_HIGHLIGHT = 13
Public Const COLOR_HIGHLIGHTTEXT = 14
Public Const COLOR_BTNFACE = 15
Public Const COLOR_BTNSHADOW = 16
Public Const COLOR_GRAYTEXT = 17
Public Const COLOR_BTNTEXT = 18
Public Const COLOR_INACTIVECAPTIONTEXT = 19
Public Const COLOR_BTNHIGHLIGHT = 20

'
' CreateProcess()
'
Public Const CREATE_NEW_CONSOLE = &H10


' System metrics
Public Const SM_CXSCREEN        As Long = 0
Public Const SM_CYSCREEN        As Long = 1


' Menus

Public Const MF_BYCOMMAND = &H0&
Public Const MF_BYPOSITION = &H400&

Public Const MF_ENABLED = &H0&
Public Const MF_DISABLED = &H2&

Public Const MF_GRAYED = &H1&

Public Const MF_UNCHECKED = &H0&
Public Const MF_CHECKED = &H8&

Public Const MF_STRING = &H0&
Public Const MF_BITMAP = &H4&
Public Const MF_OWNERDRAW = &H100&
Public Const MF_SEPARATOR = &H800&


Public Const TPM_LEFTALIGN = &H0&
Public Const TPM_CENTERALIGN = &H4&
Public Const TPM_RIGHTALIGN = &H8&

Public Const TPM_LEFTBUTTON = &H0&
Public Const TPM_RIGHTBUTTON = &H2&
Public Const TPM_NONOTIFY = &H80&
Public Const TPM_RETURNCMD = &H100&

' Undocumented - Notification messages and flags
Public Const NIM_ADD As Long = &H0&
Public Const NIM_MODIFY As Long = &H1&
Public Const NIM_DELETE As Long = &H2&

Public Const NIF_MESSAGE As Long = &H1&
Public Const NIF_ICON  As Long = &H2&
Public Const NIF_TIP  As Long = &H4&


' Virtual keycodes
Public Const KEYEVENTF_KEYUP   As Byte = &H2
Public Const VK_KEY_F          As Byte = &H46
Public Const VK_KEY_R          As Byte = &H52
Public Const VK_LWIN           As Byte = &H5B

' Hotkey modifiers
Public Const MOD_ALT = &H1
Public Const MOD_CONTROL = &H2
Public Const MOD_SHIFT = &H4
Public Const MOD_WIN = &H8  ' not defined in VB includes


'Registry
Global Const REG_NONE = 0                       ' No value type
Global Const REG_SZ = 1                         ' Unicode nul terminated string
Global Const REG_EXPAND_SZ = 2                  ' Unicode nul terminated string
Global Const REG_BINARY = 3                     ' Free form binary
Global Const REG_DWORD = 4                      ' 32-bit number
Global Const REG_DWORD_LITTLE_ENDIAN = 4        ' 32-bit number (same as REG_DWORD)
Global Const REG_DWORD_BIG_ENDIAN = 5           ' 32-bit number
Global Const REG_LINK = 6                       ' Symbolic Link (unicode)
Global Const REG_MULTI_SZ = 7                   ' Multiple Unicode strings
Global Const REG_RESOURCE_LIST = 8              ' Resource list in the resource map
Global Const REG_FULL_RESOURCE_DESCRIPTOR = 9   ' Resource list in the hardware description

' Root keys
Public Const HKEY_CLASSES_ROOT      As Long = &H80000000
Public Const HKEY_CURRENT_USER      As Long = &H80000001
Public Const HKEY_LOCAL_MACHINE     As Long = &H80000002
Public Const HKEY_USERS             As Long = &H80000003
Public Const HKEY_PERFORMANCE_DATA  As Long = &H80000004
Public Const HKEY_CURRENT_CONFIG    As Long = &H80000005
Public Const HKEY_DYN_DATA          As Long = &H80000006

Global Const ERROR_NONE = 0
Global Const ERROR_BADDB = 1
Global Const ERROR_BADKEY = 2
Global Const ERROR_CANTOPEN = 3
Global Const ERROR_CANTREAD = 4
Global Const ERROR_CANTWRITE = 5
Global Const ERROR_OUTOFMEMORY = 6
Global Const ERROR_INVALID_PARAMETER = 7
Global Const ERROR_ACCESS_DENIED = 8
Global Const ERROR_INVALID_PARAMETERS = 87
Global Const ERROR_NO_MORE_ITEMS = 259

Global Const KEY_ALL_ACCESS = &H3F

Global Const SYNCHRONIZE = &H100000
Global Const STANDARD_RIGHTS_ALL = &H1F0000
' Reg Key Security Options
Global Const KEY_QUERY_VALUE = &H1
Global Const KEY_SET_VALUE = &H2
Global Const KEY_CREATE_SUB_KEY = &H4
Global Const KEY_ENUMERATE_SUB_KEYS = &H8
Global Const KEY_NOTIFY = &H10
Global Const KEY_CREATE_LINK = &H20
'Global Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

Global Const REG_OPTION_NON_VOLATILE = 0

Public Const VER_PLATFORM_WIN32s = 0
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32_NT = 2

Public Const CP_ACP = 0  '  default to ANSI code page


' Stutting down windows
Public Const EWX_LOGOFF     As Long = &H0&
Public Const EWX_SHUTDOWN   As Long = &H1&
Public Const EWX_REBOOT     As Long = &H2&
Public Const EWX_FORCE      As Long = &H4&
Public Const EWX_POWEROFF   As Long = &H8&      ' not in VB docs

' privileges and tokens (used for shutting down under NT)
Public Type LUID
    UsedPart As Long
    IgnoredForNowHigh32BitPart As Long
End Type

Public Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    TheLuid As LUID
    Attributes As Long
End Type

Public Const TOKEN_ADJUST_PRIVILEGES = &H20
Public Const TOKEN_QUERY = &H8
Public Const SE_PRIVILEGE_ENABLED = &H2


' Windows filesystem
Global Const MAX_PATH           As Integer = 260
Public Const MAX_SIZE = 255
Public Const NOERROR = 0
Public Const INVALID_HANDLE_VALUE = -1
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
Public Const FILE_ATTRIBUTE_COMPRESSED = &H800

'
Public Const FO_DELETE = &H3
Public Const FOF_ALLOWUNDO = &H40
Public Const FOF_NOCONFIRMATION = &H10  '  Don't prompt the user.
Public Const FOF_SILENT = &H4                      '  don't create progress/report

' Used with GetVolumeInformation()
Public Const FILE_CASE_SENSITIVE_SEARCH = &H1
Public Const FILE_CASE_PRESERVED_NAMES = &H2
Public Const FILE_UNICODE_ON_DISK = &H4
Public Const FILE_PERSISTENT_ACLS = &H8
Public Const FILE_FILE_COMPRESSION = &H10
Public Const FILE_VOLUME_IS_COMPRESSED = &H8000
Public Const FS_CASE_IS_PRESERVED = FILE_CASE_PRESERVED_NAMES
Public Const FS_CASE_SENSITIVE = FILE_CASE_SENSITIVE_SEARCH
Public Const FS_PERSISTENT_ACLS = FILE_PERSISTENT_ACLS
Public Const FS_UNICODE_STORED_ON_DISK = FILE_UNICODE_ON_DISK

' constants for BROWSEINFO struct
Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000

Global Const DRIVE_NOTUSED = 1          ' (not offically defined)
Global Const DRIVE_REMOVABLE = 2
Global Const DRIVE_FIXED = 3
Global Const DRIVE_REMOTE = 4
Global Const DRIVE_CDROM = 5
Global Const DRIVE_RAMDISK = 6

Public Const ERROR_FILE_NO_ASSOCIATION = 31&
Public Const ERROR_FILE_NOT_FOUND = 2&
Public Const ERROR_PATH_NOT_FOUND = 3&
Public Const ERROR_FILE_SUCCESS = 32& 'my constant
Public Const ERROR_BAD_FORMAT = 11&


Public Const SHGFI_LARGEICON    As Long = &H0&
Public Const SHGFI_SMALLICON    As Long = &H1&
Public Const SHGFI_SHELLICONSIZE  As Long = &H4&
Public Const SHGFI_ICON         As Long = &H100&
Public Const SHGFI_DISPLAYNAME  As Long = &H200&
Public Const SHGFI_TYPENAME     As Long = &H400&
Public Const SHGFI_EXETYPE      As Long = &H2000&
Public Const SHGFI_SYSICONINDEX As Long = &H4000&

Public Const ILD_TRANSPARENT    As Long = &H1&

Public Const BASIC_SHGFI_FLAGS = SHGFI_TYPENAME _
   Or SHGFI_SHELLICONSIZE Or SHGFI_SYSICONINDEX _
   Or SHGFI_DISPLAYNAME Or SHGFI_EXETYPE

' Running apps...
Public Const SW_HIDE = 0
Public Const SW_SHOWNORMAL = 1
Public Const SW_NORMAL = 1
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_SHOWMAXIMIZED = 3
Public Const SW_MAXIMIZE = 3
Public Const SW_SHOWNOACTIVATE = 4
Public Const SW_SHOW = 5
Public Const SW_MINIMIZE = 6
Public Const SW_SHOWMINNOACTIVE = 7
Public Const SW_SHOWNA = 8
Public Const SW_RESTORE = 9
Public Const SW_SHOWDEFAULT = 10
Public Const SW_MAX = 10



' This is what we look for to get the desktop view
Public Const g_cstrShellViewWnd As String = "Progman"

' Display modes
Public Const HORZRES& = 8
Public Const VERTRES& = 10
Public Const BITSPIXEL& = 12
Public Const HORZSIZE& = 4
Public Const VERTSIZE& = 6

' DrawIconEx() constants (not in VB docs)

Public Const DI_MASK         As Long = &H1&
Public Const DI_IMAGE        As Long = &H2&
Public Const DI_NORMAL       As Long = &H3&
Public Const DI_COMPAT       As Long = &H4&
Public Const DI_DEFAULTSIZE  As Long = &H8&


' Hooks
Public Const WH_SHELL                   As Long = 10&

' WH_SHELL messages
Public Const HSHELL_WINDOWCREATED       As Long = 1
Public Const HSHELL_WINDOWDESTROYED     As Long = 2
Public Const HSHELL_ACTIVATESHELLWINDOW As Long = 3

' Locale and Date/Time

Public Const TIME_NOMINUTESORSECONDS = &H1  '  do not use minutes or seconds
Public Const TIME_NOSECONDS = &H2           '  do not use seconds
Public Const TIME_NOTIMEMARKER = &H4        '  do not use time marker
Public Const TIME_FORCE24HOURFORMAT = &H8   '  always use 24 hour format

Public Const DATE_SHORTDATE = &H1           '  use short date picture
Public Const DATE_LONGDATE = &H2            '  use long date picture

' Use GetSystemDefaultLCID() instead...
'Public Const LOCALE_USER_DEFAULT        As Long = 1&
'Public Const LOCALE_SYSTEM_DEFAULT      As Long = 2&

Public Const LOCALE_STIMEFORMAT         As Long = &H1003      '  time format string
Public Const LOCALE_SSHORTDATE          As Long = &H1F        '  short date format string
Public Const LOCALE_SLONGDATE           As Long = &H20        '  long date format string


' Win32 CSIDL's for use with ShellKit::GetSystemFolder()
'
Public Const CSIDL_DESKTOP = &H0
Public Const CSIDL_PROGRAMS = &H2
Public Const CSIDL_CONTROLS = &H3
Public Const CSIDL_PRINTERS = &H4
Public Const CSIDL_PERSONAL = &H5
Public Const CSIDL_FAVORITES = &H6
Public Const CSIDL_STARTUP = &H7
Public Const CSIDL_RECENT = &H8
Public Const CSIDL_SENDTO = &H9
Public Const CSIDL_BITBUCKET = &HA
Public Const CSIDL_STARTMENU = &HB
Public Const CSIDL_DESKTOPDIRECTORY = &H10
Public Const CSIDL_DRIVES = &H11
Public Const CSIDL_NETWORK = &H12
Public Const CSIDL_NETHOOD = &H13
Public Const CSIDL_FONTS = &H14
Public Const CSIDL_TEMPLATES = &H15
Public Const CSIDL_COMMON_STARTMENU = &H16
Public Const CSIDL_COMMON_PROGRAMS = &H17
Public Const CSIDL_COMMON_STARTUP = &H18
Public Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19
Public Const CSIDL_APPDATA = &H1A
Public Const CSIDL_PRINTHOOD = &H1B
Public Const CSIDL_ALTSTARTUP = &H1D            ' DBCS
Public Const CSIDL_COMMON_ALTSTARTUP = &H1E     ' DBCS
Public Const CSIDL_COMMON_FAVORITES = &H1F
Public Const CSIDL_INTERNET_CACHE = &H20
Public Const CSIDL_COOKIES = &H21
Public Const CSIDL_HISTORY = &H22
Public Const CSIDL_COMMONAPPDATA = &H23
Public Const CSIDL_WINDOWS = &H24
Public Const CSIDL_SYSTEM = &H25
Public Const CSIDL_PROGRAMFILES = &H26
Public Const CSIDL_MYPICTURES = &H27
Public Const CSIDL_PROFILE = &H28




Public Const STANDARD_RIGHTS_REQUIRED         As Long = &HF0000

'
' Service State -- for CurrentState
'
Public Const SERVICE_STOPPED                As Long = &H1
Public Const SERVICE_START_PENDING          As Long = &H2
Public Const SERVICE_STOP_PENDING           As Long = &H3
Public Const SERVICE_RUNNING                As Long = &H4
Public Const SERVICE_CONTINUE_PENDING       As Long = &H5
Public Const SERVICE_PAUSE_PENDING          As Long = &H6
Public Const SERVICE_PAUSED                 As Long = &H7
'
' Controls Accepted  (Bit Mask)
'
Public Const SERVICE_ACCEPT_STOP            As Long = &H1
Public Const SERVICE_ACCEPT_PAUSE_CONTINUE  As Long = &H2
Public Const SERVICE_ACCEPT_SHUTDOWN        As Long = &H4
Public Const SERVICE_ACCEPT_PARAMCHANGE     As Long = &H8
Public Const SERVICE_ACCEPT_NETBINDCHANGE   As Long = &H10
'
' Service Control Manager object specific access types
'
Public Const SC_MANAGER_CONNECT             As Long = &H1
Public Const SC_MANAGER_CREATE_SERVICE      As Long = &H2
Public Const SC_MANAGER_ENUMERATE_SERVICE   As Long = &H4
Public Const SC_MANAGER_LOCK                As Long = &H8
Public Const SC_MANAGER_QUERY_LOCK_STATUS   As Long = &H10
Public Const SC_MANAGER_MODIFY_BOOT_CONFIG  As Long = &H20

Public Const SC_MANAGER_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or _
                                            SC_MANAGER_CONNECT Or _
                                            SC_MANAGER_CREATE_SERVICE Or _
                                            SC_MANAGER_ENUMERATE_SERVICE Or _
                                            SC_MANAGER_LOCK Or _
                                            SC_MANAGER_QUERY_LOCK_STATUS Or _
                                            SC_MANAGER_MODIFY_BOOT_CONFIG)
'
' Service object specific access type
'
Public Const SERVICE_QUERY_CONFIG           As Long = &H1
Public Const SERVICE_CHANGE_CONFIG          As Long = &H2
Public Const SERVICE_QUERY_STATUS           As Long = &H4
Public Const SERVICE_ENUMERATE_DEPENDENTS   As Long = &H8
Public Const SERVICE_START                  As Long = &H10
Public Const SERVICE_STOP                   As Long = &H20
Public Const SERVICE_PAUSE_CONTINUE         As Long = &H40
Public Const SERVICE_INTERROGATE            As Long = &H80
Public Const SERVICE_USER_DEFINED_CONTROL   As Long = &H100

Public Const SERVICE_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or _
                                        SERVICE_QUERY_CONFIG Or _
                                        SERVICE_CHANGE_CONFIG Or _
                                        SERVICE_QUERY_STATUS Or _
                                        SERVICE_ENUMERATE_DEPENDENTS Or _
                                        SERVICE_START Or _
                                        SERVICE_STOP Or _
                                        SERVICE_PAUSE_CONTINUE Or _
                                        SERVICE_INTERROGATE Or _
                                        SERVICE_USER_DEFINED_CONTROL)





'==================================================================================
' TYPES and ENUMs
'==================================================================================

' Windows Filesystem
Public Type SHITEMID
    cb As Long
    abID As Byte
End Type

Public Type ITEMIDLIST
    mkid As SHITEMID
End Type

Public Type SHFILEINFO
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * MAX_PATH
    szTypeName As String * 80
End Type

'
' SFGAO definitions for dwAttributes above
'
Public Const SFGAO_FOLDER       As Long = &H20000000


Public Type SECURITY_ATTRIBUTES
     nLength As Long
     lpSecurityDescriptor As Long
     bInheritHandle As Long
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Type WIN32_FIND_DATA
     dwFileAttributes As Long
     ftCreationTime As FILETIME
     ftLastAccessTime As FILETIME
     ftLastWriteTime As FILETIME
     nFileSizeHigh As Long
     nFileSizeLow As Long
     dwReserved0 As Long
     dwReserved1 As Long
     cFileName As String * MAX_PATH
     cAlternate As String * 14
End Type

Public Type SHFILEOPSTRUCT
   hWnd        As Long
   wFunc       As Long
   pFrom       As String
   pTo         As String
   fFlags      As Integer
   fAborted    As Boolean
   hNameMaps   As Long
   sProgress   As String
 End Type
  

Public Type BROWSEINFO
   hOwner           As Long
   pidlRoot         As Long
   pszDisplayName   As String
   lpszTitle        As String
   ulFlags          As Long
   lpfn             As Long
   lParam           As Long
   iImage           As Long
End Type


'used by the RegisterHotKey method
'Public Enum RegisterHotKeyModifiers
'   MOD_ALT = &H1
'   MOD_CONTROL = &H2
'   MOD_SHIFT = &H4
'   MOD_WIN = &H8            ' not defined in VB includes
'End Enum


Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type


Public Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type



' General rectangle structure
Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

' General point structure
Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type PAINTSTRUCT
        hdc As Long
        fErase As Long
        rcPaint As RECT
        fRestore As Long
        fIncUpdate As Long
        rgbReserved(32) As Byte
End Type


Public Type WINDOWPOS
    hWnd As Long
    hWndInsertAfter As Long
    x As Long
    y As Long
    cX As Long
    cY As Long
    flags As Long
End Type

Public Type WNDCLASS
    style As Long
    lpfnwndproc As Long
    cbClsextra As Long
    cbWndExtra2 As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
End Type

Public Type WNDCLASSEX
    cbSize As Long
    style As Long
    lpfnwndproc As Long
    cbClsextra As Long
    cbWndExtra As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
    hIconSm As Long
End Type

Public Type MSG
    hWnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type


Public Type CRITICAL_SECTION
    dummy As Long
End Type

Public Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Public Type COPYDATASTRUCT
    dwData As Long
    cbData As Long
    lpData As Long
End Type


Public Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type


'==========================================
' FUNCTIONS
'==========================================

' General
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function GetVersion Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Integer
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function SetSysColors Lib "user32" (ByVal nChanges As Long, lpSysColor As Long, lpColorValues As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Public Declare Function Shell0x3C Lib "shell32" Alias "#60" (ByVal hWnd As Long) As Long
Public Declare Function SHRunDialog Lib "shell32" Alias "#61" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal szTitle As String, ByVal szPrompt As String, ByVal uFlags As Long) As Long


Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Public Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Public Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As SECURITY_ATTRIBUTES, lpThreadAttributes As SECURITY_ATTRIBUTES, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Public Declare Function CreateProcessNoSA Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As Long, lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long


Public Declare Function GetCurrentThreadId Lib "kernel32" () As Long
Public Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, ByVal lpParameter As Long, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
'Public Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As SECURITY_ATTRIBUTES, ByVal dwStackSize As Long, lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, lpExitCode As Long) As Long
Public Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)

Public Declare Function WinExec Lib "kernel32" (ByVal lpCmdLine As String, ByVal nCmdShow As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public Declare Sub InitializeCriticalSection Lib "kernel32" (lpCriticalSection As CRITICAL_SECTION)
Public Declare Sub DeleteCriticalSection Lib "kernel32" (lpCriticalSection As CRITICAL_SECTION)
Public Declare Sub EnterCriticalSection Lib "kernel32" (lpCriticalSection As CRITICAL_SECTION)
Public Declare Sub LeaveCriticalSection Lib "kernel32" (lpCriticalSection As CRITICAL_SECTION)


Public Declare Function OpenSCManager Lib "advapi32.dll" Alias "OpenSCManagerA" (ByVal lpMachineName As String, ByVal lpDatabaseName As String, ByVal dwDesiredAccess As Long) As Long
Public Declare Function OpenService Lib "advapi32.dll" Alias "OpenServiceA" (ByVal hSCManager As Long, ByVal lpServiceName As String, ByVal dwDesiredAccess As Long) As Long
Public Declare Function CloseServiceHandle Lib "advapi32.dll" (ByVal hSCObject As Long) As Long
Public Declare Function QueryServiceStatus Lib "advapi32.dll" (ByVal hService As Long, lpServiceStatus As SERVICE_STATUS) As Long
Public Declare Function StartService Lib "advapi32.dll" Alias "StartServiceA" (ByVal hService As Long, ByVal dwNumServiceArgs As Long, ByVal lpServiceArgVectors As Long) As Long



Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Public Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Sub CopyMemoryDestAddr Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest&, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemorySrcAddr Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, ByVal numBytes As Long)


' Registry
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long

Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long


' Hotkeys
Public Declare Function RegisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As KeyCodeConstants) As Long
Public Declare Function UnregisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long) As Long

' Atoms

Public Declare Function GlobalAddAtom Lib "kernel32" _
   Alias "GlobalAddAtomA" _
  (ByVal lpString As String) As Long
   
Public Declare Function GlobalDeleteAtom Lib "kernel32" _
   (ByVal nAtom As Long) As Long


Public Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As String, ByVal cchWideChar As Long, ByVal lpMultiByteStr As String, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long


' Window related
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd _
    As Long, ByVal hWndInsertAfter As Long, ByVal x As _
    Long, ByVal y As Long, ByVal cX As Long, ByVal cY _
    As Long, ByVal wFlags As Long) As Long

Public Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (Class As WNDCLASS) As Long
Public Declare Function RegisterClassEx Lib "user32" Alias "RegisterClassExA" (pcWndClassEx As WNDCLASSEX) As Integer
Public Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassA" (ByVal lpClassName As String, ByVal hInstance As Long) As Long
Public Declare Function SetClassLong Lib "user32" Alias "SetClassLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hwndParent As Long, ByVal g_hMenu As Long, ByVal hInstance As Long, lpParam As Long) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx& Lib "user32" Alias "FindWindowExA" (ByVal hwndParent As Long, ByVal hWndChildAfter As Long, ByVal lpClassName As String, ByVal lpWindowName As String)
Public Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal flgs As Long) As Long
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Public Declare Function GetWindowWord Lib "user32" (ByVal hWnd As Long, ByVal wIndx As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal wIndx As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal wNewWord As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetForegroundWindow Lib "user32" () As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function SetActiveWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpSting As String, ByVal nMaxCount As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Public Declare Function AttachThreadInput Lib "user32" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long
Public Declare Function IsIconic Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Public Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long

Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long

Public Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Public Declare Function SetFocus Lib "user32" (ByVal hWnd As Long) As Long


'
' Messages
'
Public Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Public Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As MSG) As Long
Public Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As MSG, ByVal hWnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Public Declare Function GetMessagePos Lib "user32" () As Long
Public Declare Sub PostQuitMessage Lib "user32" (ByVal nExitCode As Long)
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageByLong& Lib "user32" Alias "SendMessageA" (ByVal hWnd&, ByVal wMsg&, ByVal wParam&, ByVal lParam&)
Public Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long



' Filesystem
Public Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbSizeFileInfo As Long, ByVal uFlags As Long) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal Pidl As Long, ByVal pszPath As String) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Public Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, Pidl As ITEMIDLIST) As Long
Public Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Public Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Public Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal sResult As String) As Long
Public Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Public Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long
Public Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long
Public Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Public Declare Function GetCompressedFileSize Lib "kernel32" Alias "GetCompressedFileSizeA" (ByVal lpFileName As String, lpFileSizeHigh As Long) As Long
Public Declare Function SearchPath Lib "kernel32" Alias "SearchPathA" (ByVal lpPath As String, ByVal lpFileName As String, ByVal lpExtension As String, ByVal nBufferLength As Long, ByVal lpBuffer As String, ByVal lpFilePart As String) As Long

Public Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long

Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)

Public Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As _
    Long, ByVal i As Long, ByVal hDCDest As Long, ByVal x As Long, ByVal _
    y As Long, ByVal flags As Long) As Long

' icons

Public Declare Function CopyIcon Lib "user32" (ByVal hIcon As Long) As Long
Public Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long
Public Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Public Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long


' Display modes

Public Declare Function GetDeviceCaps& Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long)

Public Declare Function SystemParametersInfo Lib "user32" _
      Alias "SystemParametersInfoA" _
     (ByVal uAction As Long, _
      ByVal uParam As Long, _
      lpvParam As Any, _
      ByVal fuWinIni As Long) As Long

Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
    

' Graphics


Public Declare Function BeginPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long
Public Declare Function EndPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long

Public Declare Function BitBlt Lib "gdi32" _
  (ByVal hDCDest As Long, ByVal XDest As Long, _
   ByVal YDest As Long, ByVal nWidth As Long, _
   ByVal nHeight As Long, ByVal hdcSrc As Long, _
   ByVal xSrc As Long, ByVal ySrc As Long, _
   ByVal dwRop As Long) As Long

Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Public Declare Function CreateBitmap Lib "gdi32" _
  (ByVal nWidth As Long, _
   ByVal nHeight As Long, _
   ByVal nPlanes As Long, _
   ByVal nBitCount As Long, _
   lpBits As Any) As Long

Public Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long

Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
Public Declare Function OpenProcessToken Lib "advapi32" (ByVal _
    ProcessHandle As Long, ByVal DesiredAccess As Long, _
    TokenHandle As Long) As Long

Public Declare Function LookupPrivilegeValue Lib "advapi32" Alias _
    "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal _
    lpName As String, lpLuid As LUID) As Long

Public Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal _
    TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState _
    As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As _
    TOKEN_PRIVILEGES, ReturnLength As Long) As Long

Public Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As String) As Long
Public Declare Function LoadCursorSys Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long

'
' Locales & date/time formatting
'
Public Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
Public Declare Function GetTimeFormat Lib "kernel32" Alias "GetTimeFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpTime As SYSTEMTIME, ByVal lpFormat As String, ByVal lpTimeStr As String, ByVal cchTime As Long) As Long
Public Declare Function GetDateFormat Lib "kernel32" Alias "GetDateFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As SYSTEMTIME, ByVal lpFormat As String, ByVal lpDateStr As String, ByVal cchDate As Long) As Long
Public Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Public Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
Public Declare Function GetUserDefaultLCID Lib "kernel32" () As Long

'
' Menus
'
Public Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Public Declare Function CreatePopupMenu Lib "user32" () As Long
Public Declare Function DestroyMenu Lib "user32" (ByVal g_hMenu As Long) As Long
Public Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal g_hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Public Declare Function ModifyMenu Lib "user32" Alias "ModifyMenuA" (ByVal g_hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpString As Any) As Long
Public Declare Function EnableMenuItem Lib "user32" (ByVal g_hMenu As Long, ByVal wIDEnableItem As Long, ByVal wEnable As Long) As Long
Public Declare Function TrackPopupMenu Lib "user32" (ByVal g_hMenu As Long, ByVal wFlags As Long, ByVal x As Long, ByVal y As Long, ByVal nReserved As Long, ByVal hWnd As Long, lprc As RECT) As Long


Public Type BLENDFUNCTION
    BlendOp As Byte                 ' AC_SRC_OVER
    BlendFlags As Byte              ' zero
    SourceConstantAlpha As Byte     ' 0..255
    AlphaFormat As Byte             ' AC_SRC_ALPHA
End Type


'
' Windows2000 layered windows (thanks to vbcode.com for this!)
'
Public Declare Function SetLayeredWindowAttributes Lib _
    "user32" (ByVal hWnd As Long, ByVal crKey As Long, _
    ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

Public Declare Function UpdateLayeredWindow Lib _
    "user32" (ByVal hWnd As Long, ByVal hdcDst As Long, _
    ByVal pptDst As Long, ByVal psize As Long, ByVal hdcSrc As Long, _
    ByVal pptSrc As Long, ByVal crKey As Long, pblend As BLENDFUNCTION, _
    ByVal dwFlags As Long) As Boolean
    

'BOOL UpdateLayeredWindow(
'  HWND hwnd,             // handle to layered window
'  HDC hdcDst,            // handle to screen DC
'  POINT *pptDst,         // new screen position
'  SIZE *psize,           // new size of the layered window
'  HDC hdcSrc,            // handle to surface DC
'  POINT *pptSrc,         // layer position
'  COLORREF crKey,        // color key
'  BLENDFUNCTION *pblend, // blend function
'  DWORD dwFlags          // options


Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Type COSERVERINFO
    dwReserved1 As Long ' DWORD
    pwszName As Long ' LPWSTR
    pAuthInfo As Long ' COAUTHINFO*
    dwReserved2 As Long ' DWORD
End Type

Public Type MULTI_QI
    piid As Long ' const IID*
    pItf As Object ' IUnknown*
    hr As Long ' HRESULT
End Type

Public Const S_OK As Long = 0

Public Const CLASS_E_NOAGGREGATION      As Long = &H80040110
Public Const REGDB_E_CLASSNOTREG        As Long = &H80040154
Public Const CO_E_CLASSSTRING           As Long = &H800401F3

Public Const E_INVALIDARG               As Long = &H80070057

Public Const E_NOINTERFACE              As Long = &H80004002

Public Const CLSCTX_INPROC_SERVER = 1
Public Const CLSCTX_INPROC_HANDLER = 2
Public Const CLSCTX_LOCAL_SERVER = 4
Public Const CLSCTX_REMOTE_SERVER = 16
Public Const CLSCTX_SERVER = CLSCTX_INPROC_SERVER + CLSCTX_LOCAL_SERVER + CLSCTX_REMOTE_SERVER
Public Const CLSCTX_ALL = CLSCTX_INPROC_SERVER + CLSCTX_INPROC_HANDLER + CLSCTX_LOCAL_SERVER + CLSCTX_REMOTE_SERVER

Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function IIDFromString Lib "ole32" (ByVal lpszIID As String, ByVal piid As Long) As Long
Public Declare Function CLSIDFromString Lib "ole32" (ByVal lpszCLSID As String, pclsid As GUID) As Long
Public Declare Function CLSIDFromProgID Lib "ole32" (ByVal lpszProgID As String, pclsid As GUID) As Long
Public Declare Function CoCreateInstanceEx Lib "ole32" (rclsid As GUID, ByVal pUnkOuter As Long, ByVal dwClsContext As Long, pServerInfo As COSERVERINFO, ByVal cmq As Long, rgmqResults As MULTI_QI) As Long
Public Declare Function CoCreateInstance Lib "ole32" (ByRef rclsid As GUID, ByVal pUnkOuter As Long, ByVal dwContent As Long, ByRef riid As GUID, ByRef ppv As Long) As Long

